/*
 * -------------------------------------------------------------------- *
 *  STRONGMAIL SYSTEMS                                                  *
 *                                                                      *
 *  Copyright 2016 StrongMail Systems, Inc. - All rights reserved.      *
 *                                                                      *
 *  Visit http://www.strongmail.com for more information                *
 *                                                                      *
 *  You may incorporate this Source Code in your application only if    *
 *  you own a valid license to do so from StrongMail Systems, Inc.      *
 *  and the copyright notices are not removed from the source code.     *
 *                                                                      *
 *  Distributing our source code outside your organization              *
 *  is strictly prohibited                                              *
 *                                                                      *
 * -------------------------------------------------------------------- *
 */

package com.strongmail.restclient.samples;

import com.jayway.restassured.builder.RequestSpecBuilder;
import com.jayway.restassured.response.Response;
import com.strongmail.restclient.Record;
import com.strongmail.restclient.RecordListBean;
import com.strongmail.restclient.RestClientStore;
import groovy.json.JsonOutput;

import java.util.ArrayList;
import java.util.List;

import static com.jayway.restassured.RestAssured.given;


public class MailingSample {

  public void txnSend(Long mailingId) {

    List<Record> records = new ArrayList<>();
    for(int i = 1; i <= 3; i++) {
      Record record = new Record();
      record.add("user_id", "" + i);
      record.add("email_address", "test00" + i + "@localtest.com");
      record.add("name", "User_" + i);
      records.add(record);
    }

    RecordListBean recordsBean = new RecordListBean();
    recordsBean.setRecords(records);

    RequestSpecBuilder builder = RestClientStore.setup();
    builder.setBody(JsonOutput.toJson(recordsBean));

    // TxnSend api URI: sm/rest/v1/mailings/transactional/{mailing_id}/records
    String uri = RestClientStore.getBaseUrl() + "/mailings/transactional/" + mailingId + "/records";
    Response response = given(builder.build()).post(uri);

    System.out.println("Response " + response.asString());
  }
}
